#include "fournisseur.h"
#include <iostream>
#include <string>
#include <windows.h>

using pf_debuter_t = void FOURNISSEUR_API (__stdcall *)(unsigned int, unsigned int);
using pf_terminer_t = void FOURNISSEUR_API (__stdcall *)();
using pf_get_fill_count_t = int FOURNISSEUR_API  (__stdcall *)();
using pf_get_buffer_blocks_t = void FOURNISSEUR_API (__stdcall *)(buffer_block**);

int main() {
   using namespace std;
   const auto NOM_DLL = L"TP00--fournisseur.dll";
   HMODULE module = LoadLibrary(NOM_DLL);
   auto pf_debuter =
      reinterpret_cast<pf_debuter_t>(GetProcAddress(module, "debuter"));
   auto pf_terminer =
      reinterpret_cast<pf_terminer_t>(GetProcAddress(module, "terminer"));
   auto pf_get_fill_count =
      reinterpret_cast<pf_get_fill_count_t>(GetProcAddress(module, "get_fill_count"));
   auto pf_get_buffer_blocks =
      reinterpret_cast<pf_get_buffer_blocks_t>(GetProcAddress(module, "get_buffer_blocks"));
   pf_debuter(100, 0);
   int cur_fill = pf_get_fill_count();
   enum { NESSAIS = 5 };
   for (int i = 0; i < NESSAIS; ++i) {
      int candidat;
      while (candidat = pf_get_fill_count(), candidat == cur_fill)
         ;
      if (candidat - cur_fill > 1)
         cout << '\a' << endl;
      buffer_block *p_block = nullptr;
      pf_get_buffer_blocks(&p_block);
      int last_buf_filled = p_block->last_buffer_filled;
      auto &data = p_block->data[last_buf_filled];
      for (int i = 0; i < raw_data::BLOCK_SIZE; ++i)
         cout << data.values[i] << ' ';
      cout << endl;
      cur_fill = candidat;
   }
   pf_terminer();
   FreeLibrary(module);
}
